//File to Clip
//(c) Jeremy Smith 2009
//Licensed under the BSD license and all that it implies.
//Use it however you want and in whatever application you choose, just include this copyright notice

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

int main(int argc,char **argv)
{
	if (argc == 2)
	{
		//Read file into buffer
		FILE *inp;
		inp = fopen(argv[1],"rb");
		if (inp)
		{
			fseek(inp,0L,SEEK_END);
			unsigned long filesize = ftell(inp);
			fseek(inp,0L,SEEK_SET);
			unsigned char *temp = (unsigned char *)malloc(filesize+1);
			fread(temp,1,filesize,inp);
			fclose(inp);
			temp[filesize] = 0;

			// Open the clipboard...
			if(OpenClipboard(0)) {
        
				// Empty what's in there...
				EmptyClipboard();
        
				// Allocate global memory for transfer...
				HGLOBAL hText = GlobalAlloc(GMEM_MOVEABLE |GMEM_DDESHARE, strlen((const char *)temp)+4);
        
				// Put your string in the global memory...
				char *ptr = (char *)GlobalLock(hText);
				strcpy(ptr, (const char *)temp);
				GlobalUnlock(hText);
        
				SetClipboardData(CF_TEXT, hText);
        
				CloseClipboard();
				// Free memory...
				GlobalFree(hText);        
			}

			// Clean up...
			delete [] temp;
		}
		else
		{
			printf("Cannot open specified input file\n");
		}
	}
	else
	{
		printf("File2Clip (c) 2009 San Fran Systems\n");
		printf("sanfransys@decompiler.org\n");
		printf("To use: File2Clip <filename>\n");
		printf("This will load that text file into the clipboard\n");
	}
}

